/*
 * This code is in the public domain; do with it what you wish.
 *
 **/
#include <stdio.h>
#include "CP_RSA.h"
#include "base64.h"

int main (int argc, char ** argv)
{
	if (argc < 3 || argc > 4) {
		printf("usage: %s [--no-b64encode] <public-key> <text>\n", argv[0]);
		return -1;
	}

	bool b64encode = true;
	int current_arg = 1;
	if (0 == strcmp(argv[current_arg], "--no-b64encode")) {
		++current_arg;
		b64encode = false;
	}

	const char * serialized_public_key = argv[current_arg++];
	std::string text = argv[current_arg];

	CCryptoProviderRSA encrypter;
	encrypter.ImportPublicKey(serialized_public_key);

	char crypted_text[MAX_CRYPT_BITS / sizeof(char)] = "\0";
	size_t crypted_len = 0;
	encrypter.Encrypt(text.c_str(), text.size(), crypted_text, crypted_len);
	if (b64encode) {
		std::string b64_crypted_text = base64_encode((unsigned char *)crypted_text, crypted_len);
		puts(b64_crypted_text.c_str());
	} else {
		fwrite(crypted_text, crypted_len, 1, stdout);
		fflush(stdout);
	}

	return 0;
}
